/*

   	 $Id: calendarlatexprinter.h,v 1.2 1998/07/19 03:26:51 boloni Exp $	

	 Requires the Qt and KDE widget libraries, available at no cost at
	 http://www.troll.no and http://www.kde.org respectively
	 
	 Copyright (C) 1997, 1998 	 
	 Preston Brown (preston.brown@yale.edu)
	 Fester Zigterman (F.J.F.ZigtermanRustenburg@student.utwente.nl)
	 Ian Dawes (iadawes@globalserve.net)
	 Neil Hart (nhart@magma.ca)
	 Laszlo Boloni (boloni@cs.purdue.edu)
	 
	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.
	 
	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
	 GNU General Public License for more details.
	 
	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _CALENDARLATEXPRINTER_H
#define _CALENDARLATEXPRINTER_H

#include "kprocess.h"
#include "calobject.h"

class CalendarLatexPrinter : public QObject {
	Q_OBJECT
private:

    CalObject *calendar;    
    // printing options - should be settable from the configuration    
    char filename[1000];
    FILE *file;
    enum mode {};
    QDate start, end;
    KConfig *config;		// config for the whole app
    KProcess dvipr, kghostview; // these can not be captured...
public:   
    static CalendarLatexPrinter *_instance; // it is a singleton
    bool dvi_preview;
    bool print_completed_todos;
    bool use_ulem;
    // print method 
    static CalendarLatexPrinter* getInstance(CalObject *cal);
    CalendarLatexPrinter(CalObject *cal);
    ~CalendarLatexPrinter();
    void setDates(QDate from, QDate to);
    void print();
    void preview();
    void generate();
    bool checkTermination(KProcess *proc, char *execname);

public slots:
    void print2(KProcess *);
    void pspreview2(KProcess *);
    void pspreview3(KProcess *);
};

#endif // _CALENDARLATEXPRINTER_H
