// 	$Id: catdlg.cpp,v 1.4 1998/01/17 23:04:13 pbrown Exp $	

#include <qlabel.h>
#include <qpushbt.h>
#include <qlist.h>
#include <stdio.h>

#include "catdlg.h"
#include "catdlg.moc"

CategoryDialog::CategoryDialog(QWidget* parent,const char* name)
  : QDialog( parent, name, FALSE, 0 )
{
  catListBox = new QListBox( this, "ListBox_1" );
  catListBox->setGeometry( 10, 160, 380, 230 );
  catListBox->setMinimumSize( 10, 10 );
  catListBox->setMaximumSize( 32767, 32767 );
  catListBox->setFrameStyle( 51 );
  catListBox->setLineWidth( 2 );
  catListBox->setMultiSelection( TRUE );

  selectedCatEdit = new QMultiLineEdit( this, "MultiLineEdit_1" );
  selectedCatEdit->setGeometry( 10, 50, 240, 70 );
  selectedCatEdit->setMinimumSize( 10, 10 );
  selectedCatEdit->setMaximumSize( 32767, 32767 );
  selectedCatEdit->insertLine( "" );
  selectedCatEdit->setReadOnly( TRUE );
  selectedCatEdit->setOverwriteMode( FALSE );

  QLabel* label_1;
  label_1 = new QLabel( this, "Label_1" );
  label_1->setGeometry( 10, 30, 140, 20 );
  label_1->setMinimumSize( 10, 10 );
  label_1->setMaximumSize( 32767, 32767 );
  label_1->setText( "Selected Categories:" );
  label_1->setAlignment( 289 );
  label_1->setMargin( -1 );

  QLabel* label_2;
  label_2 = new QLabel( this, "Label_2" );
  label_2->setGeometry( 10, 140, 140, 20 );
  label_2->setMinimumSize( 10, 10 );
  label_2->setMaximumSize( 32767, 32767 );
  label_2->setText( "Available Categories:" );
  label_2->setAlignment( 289 );
  label_2->setMargin( -1 );
  
  QPushButton *ok, *cancel;
  ok = new QPushButton( "Ok", this );
  ok->setDefault(TRUE);
  ok->setGeometry( 220,410, 80,20 );
  connect( ok, SIGNAL(clicked()), SLOT(accept()) );

  cancel = new QPushButton( "Cancel", this );
  cancel->setGeometry( 310,410, 80,20 );
  connect( cancel, SIGNAL(clicked()), SLOT(reject()) );
  

  setCaption("Category Dialog");
  resize( 400,450 );
  setMinimumSize( 400, 450 );
  setMaximumSize( 400, 450 );

  catList.append("Appointment");
  catList.append("Business");
  catList.append("Meeting");
  catList.append("Phone Call");
  catList.append("Education");
  catList.append("Holiday");
  catList.append("Vacation");
  catList.append("Special Occasion");
  catList.append("Personal");
  catList.append("Travel");
  catList.append("Miscellaneous");
  catListBox->insertStrList(&catList);

  connect(catListBox, SIGNAL(selectionChanged()),
	  this, SLOT(updatePicked()));
  
}


CategoryDialog::~CategoryDialog()
{
}

void CategoryDialog::updatePicked()
{
  uint index;
  QString tmpStr;

  selectedCats.clear();

  for (index = 0; index < catListBox->count(); index++) {
    if (catListBox->isSelected(index))
      selectedCats.append(catListBox->text(index));
  }
  selectedCatEdit->clear();
  tmpStr = "";
  QStrListIterator it(selectedCats);
  index = 0;
  for (; it.current(); ++it) {
    ++index;
    tmpStr += it.current();
    if (!it.atLast()) {
      if ((index % 3))
	tmpStr += ", ";
      else 
	tmpStr += ",\n";
    }
  }
  selectedCatEdit->append(tmpStr.data());
  
}

void CategoryDialog::accept()
{
  emit okClicked(QString(selectedCatEdit->text()));
  done(Accepted);
}
