// 	$Id: eventwindetails.cpp,v 1.11 1998/08/03 13:00:26 pbrown Exp $	

#include <qslider.h>
#include <qlined.h>
#include <qlistbox.h>
#include <qpixmap.h>
#include <kiconloader.h>
#include <kapp.h>

#include "eventwindetails.moc"

EventWinDetails::EventWinDetails (QWidget* parent, const char* name, bool todo)
  : QFrame( parent, name, 0 )
{
   isTodo = todo;
    
  resize( 600,400 );
  initAttendee();
  initAttach();
  initMisc();

  setMinimumSize( 600, 400 );
  setMaximumSize( 32767, 32767 );
}

void EventWinDetails::initAttendee()
{

  attendeeGroupBox = new QGroupBox( this, "User_1" );
  attendeeGroupBox->setTitle(i18n("Attendee Information"));
  attendeeGroupBox->setGeometry( 10, 10, 580, 170 );
  attendeeGroupBox->setMinimumSize( 10, 10 );
  attendeeGroupBox->setMaximumSize( 32767, 32767 );

  attendeeListBox = new KTabListBox( this, "ListBox_1", 4);
  attendeeListBox->setGeometry( 300, 20, 280, 150 );
  attendeeListBox->setMinimumSize( 10, 10 );
  attendeeListBox->setMaximumSize( 32767, 32767 );
  attendeeListBox->setColumn(0, "Attendee Name", 200);
  attendeeListBox->setColumn(1, "Role", 80);
  attendeeListBox->setColumn(2, "Status", 80);
  attendeeListBox->setColumn(3, "RSVP", 30, KTabListBox::PixmapColumn);
  attendeeListBox->dict().insert("Y", new QPixmap(Icon("checkedbox.xpm")));
  attendeeListBox->dict().insert("N", new QPixmap(Icon("emptybox.xpm")));

  connect(attendeeListBox, SIGNAL(highlighted(int, int)),
	  this, SLOT(attendeeListHilite(int, int)));
  connect(attendeeListBox, SIGNAL(selected(int, int)),
	  this, SLOT(attendeeListAction(int, int)));

  attendeeLabel = new QLabel( this, "Label_1" );
  attendeeLabel->setGeometry( 20, 30, 100, 20 );
  attendeeLabel->setMinimumSize( 10, 10 );
  attendeeLabel->setMaximumSize( 32767, 32767 );
  attendeeLabel->setText( i18n("Attendee Name:") );
  attendeeLabel->setAlignment( 289 );
  attendeeLabel->setMargin( -1 );

  attendeeEdit = new QLineEdit( this, "LineEdit_1" );
  attendeeEdit->setGeometry( 20, 50, 260, 20 );
  attendeeEdit->setMinimumSize( 10, 10 );
  attendeeEdit->setMaximumSize( 32767, 32767 );
  attendeeEdit->setText( "" );

  addAttendeeButton = new QPushButton( this, "PushButton_1" );
  addAttendeeButton->setGeometry( 20, 80, 100, 20 );
  addAttendeeButton->setMinimumSize( 10, 10 );
  addAttendeeButton->setMaximumSize( 32767, 32767 );
  addAttendeeButton->setText( i18n("Add") );
  connect(addAttendeeButton, SIGNAL(clicked()),
	  this, SLOT(addAttendee()));

  addressBookButton = new QPushButton( this, "PushButton_6" );
  addressBookButton->setGeometry( 20, 110, 100, 20 );
  addressBookButton->setMinimumSize( 10, 10 );
  addressBookButton->setMaximumSize( 32767, 32767 );
  addressBookButton->setText( i18n("Address Book...") );
  connect(addressBookButton, SIGNAL(clicked()),
	  this, SLOT(openAddressBook()));

  removeAttendeeButton = new QPushButton( this, "PushButton_2" );
  removeAttendeeButton->setGeometry( 20, 140, 100, 20 );
  removeAttendeeButton->setMinimumSize( 10, 10 );
  removeAttendeeButton->setMaximumSize( 32767, 32767 );
  removeAttendeeButton->setText( i18n("Remove") );
  connect(removeAttendeeButton, SIGNAL(clicked()),
	  this, SLOT(removeAttendee()));

  attendeeRoleLabel = new QLabel( this, "Label_2" );
  attendeeRoleLabel->setGeometry( 130, 110, 40, 20 );
  attendeeRoleLabel->setMinimumSize( 10, 10 );
  attendeeRoleLabel->setMaximumSize( 32767, 32767 );
  attendeeRoleLabel->setText( i18n("Role:") );
  attendeeRoleLabel->setAlignment( 289 );
  attendeeRoleLabel->setMargin( -1 );

  attendeeRoleCombo = new QComboBox( FALSE, this, "ComboBox_1" );
  attendeeRoleCombo->setGeometry( 170, 110, 100, 20 );
  attendeeRoleCombo->setMinimumSize( 10, 10 );
  attendeeRoleCombo->setMaximumSize( 32767, 32767 );
  attendeeRoleCombo->setSizeLimit( 10 );
  attendeeRoleCombo->insertItem( i18n("Attendee") );
  attendeeRoleCombo->insertItem( i18n("Organizer") );
  attendeeRoleCombo->insertItem( i18n("Owner") );
  attendeeRoleCombo->insertItem( i18n("Delegate") );

//   attendeeRSVPButton = new QCheckBox( this, "CheckBox_1" );
//   attendeeRSVPButton->setGeometry( 130, 80, 120, 20 );
//   attendeeRSVPButton->setMinimumSize( 10, 10 );
//   attendeeRSVPButton->setMaximumSize( 32767, 32767 );
//   attendeeRSVPButton->setText( i18n("RSVP Requested") );

  statusLabel = new QLabel( this, "Label_3" );
  statusLabel->setGeometry( 130, 140, 50, 20 );
  statusLabel->setMinimumSize( 10, 10 );
  statusLabel->setMaximumSize( 32767, 32767 );
  statusLabel->setText( i18n("Status:") );
  statusLabel->setAlignment( 289 );
  statusLabel->setMargin( -1 );

  statusCombo = new QComboBox( FALSE, this, "ComboBox_2" );
  statusCombo->setGeometry( 170, 140, 120, 20 );
  statusCombo->setMinimumSize( 10, 10 );
  statusCombo->setMaximumSize( 32767, 32767 );
  statusCombo->setSizeLimit( 10 );
  statusCombo->insertItem( i18n("Needs Action") );
  statusCombo->insertItem( i18n("Accepted") );
  statusCombo->insertItem( i18n("Sent") );
  statusCombo->insertItem( i18n("Tentative") );
  statusCombo->insertItem( i18n("Confirmed") );
  statusCombo->insertItem( i18n("Declined") );
  statusCombo->insertItem( i18n("Completed") );
  statusCombo->insertItem( i18n("Delegated") );

}
    
void EventWinDetails::initAttach()
{

  attachGroupBox = new QGroupBox( this, "User_2" );
  attachGroupBox->setGeometry( 10, 190, 580, 100 );
  attachGroupBox->setMinimumSize( 10, 10 );
  attachGroupBox->setMaximumSize( 32767, 32767 );

  attachFileButton = new QPushButton( this, "PushButton_3" );
  attachFileButton->setGeometry( 20, 200, 100, 20 );
  attachFileButton->setMinimumSize( 10, 10 );
  attachFileButton->setMaximumSize( 32767, 32767 );
  attachFileButton->setText( i18n("Attach...") );

  removeFileButton = new QPushButton( this, "PushButton_4" );
  removeFileButton->setGeometry( 20, 260, 100, 20 );
  removeFileButton->setMinimumSize( 10, 10 );
  removeFileButton->setMaximumSize( 32767, 32767 );
  removeFileButton->setText( i18n("Remove") );

  attachListBox = new KTabListBox( this, "ListBox_2" );
  attachListBox->setGeometry( 140, 200, 440, 80 );
  attachListBox->setMinimumSize( 10, 10 );
  attachListBox->setMaximumSize( 32767, 32767 );

  saveFileAsButton = new QPushButton( this, "PushButton_5" );
  saveFileAsButton->setGeometry( 20, 230, 100, 20 );
  saveFileAsButton->setMinimumSize( 10, 10 );
  saveFileAsButton->setMaximumSize( 32767, 32767 );
  saveFileAsButton->setText( i18n("Save As...") );
}

void EventWinDetails::initMisc()
{

  categoriesButton = new QPushButton( this, "PushButton_7" );
  categoriesButton->setGeometry( 20, 300, 100, 20 );
  categoriesButton->setMinimumSize( 10, 10 );
  categoriesButton->setMaximumSize( 32767, 32767 );
  categoriesButton->setText( i18n("Categories...") );

  categoriesEdit = new QLineEdit( this, "LineEdit_2" );
  categoriesEdit->setGeometry( 140, 300, 250, 20 );
  categoriesEdit->setMinimumSize( 10, 10 );
  categoriesEdit->setMaximumSize( 32767, 32767 );
  categoriesEdit->setText( "" );
  categoriesEdit->setMaxLength( 32767 );

  locationLabel = new QLabel( this, "Label_4" );
  locationLabel->setGeometry( 50, 360, 70, 20 );
  locationLabel->setMinimumSize( 10, 10 );
  locationLabel->setMaximumSize( 32767, 32767 );
  locationLabel->setText( i18n("Location:") );
  locationLabel->setAlignment( 289 );
  locationLabel->setMargin( -1 );

  priorityLabel = new QLabel( this, "Label_5" );
  priorityLabel->setGeometry( 400, 300, 60, 20 );
  priorityLabel->setMinimumSize( 10, 10 );
  priorityLabel->setMaximumSize( 32767, 32767 );
  priorityLabel->setText( i18n("Priority:") );
  priorityLabel->setAlignment( 289 );
  priorityLabel->setMargin( -1 );

  priorityCombo = new QComboBox( FALSE, this, "ComboBox_3" );
  priorityCombo->setGeometry( 490, 300, 80, 20 );
  priorityCombo->setMinimumSize( 10, 10 );
  priorityCombo->setMaximumSize( 32767, 32767 );
  priorityCombo->setSizeLimit( 10 );
  priorityCombo->insertItem( i18n("Low") );
  priorityCombo->insertItem( i18n("Normal") );
  priorityCombo->insertItem( i18n("High") );
  priorityCombo->insertItem( i18n("Maximum") );

  resourceButton = new QPushButton( this, "PushButton_9" );
  resourceButton->setGeometry( 20, 330, 100, 20 );
  resourceButton->setMinimumSize( 10, 10 );
  resourceButton->setMaximumSize( 32767, 32767 );
  resourceButton->setText( i18n("Resources...") );

  resourcesEdit = new QLineEdit( this, "LineEdit_4" );
  resourcesEdit->setGeometry( 140, 330, 250, 20 );
  resourcesEdit->setMinimumSize( 10, 10 );
  resourcesEdit->setMaximumSize( 32767, 32767 );
  resourcesEdit->setText( "" );
  resourcesEdit->setMaxLength( 32767 );

  transparencyLabel = new QLabel( this, "Label_6" );
  transparencyLabel->setGeometry( 400, 330, 90, 20 );
  transparencyLabel->setMinimumSize( 10, 10 );
  transparencyLabel->setMaximumSize( 32767, 32767 );
  transparencyLabel->setText( i18n("Transparency:") );
  transparencyLabel->setAlignment( 289 );
  transparencyLabel->setMargin( -1 );

  /*  QSlider* dlgedit_Slider_1;
  dlgedit_Slider_1 = new QSlider( this, "Slider_1" );
  dlgedit_Slider_1->setGeometry( 490, 330, 90, 20 );
  dlgedit_Slider_1->setMinimumSize( 10, 10 );
  dlgedit_Slider_1->setMaximumSize( 32767, 32767 );
  dlgedit_Slider_1->setOrientation( QSlider::Horizontal );
  dlgedit_Slider_1->setRange( 0, 99 );
  dlgedit_Slider_1->setSteps( 1, 10 );
  dlgedit_Slider_1->setValue( 0 );
  dlgedit_Slider_1->setTracking( TRUE );
  dlgedit_Slider_1->setTickmarks( QSlider::NoMarks );
  dlgedit_Slider_1->setTickInterval( 0 );*/

  transparencyAmountLabel = new QLabel( this, "Label_7" );
  transparencyAmountLabel->setGeometry( 520, 350, 30, 20 );
  transparencyAmountLabel->setMinimumSize( 10, 10 );
  transparencyAmountLabel->setMaximumSize( 32767, 32767 );
  transparencyAmountLabel->setText( "0" );
  transparencyAmountLabel->setAlignment( 292 );
  transparencyAmountLabel->setMargin( -1 );

}


EventWinDetails::~EventWinDetails()
{
}


void EventWinDetails::addAttendee()
{

  if (strcmp(attendeeEdit->text(), "") != 0) {
    // do stuff for address book
    QString tmpStr;
    tmpStr.sprintf("%s\n \n \nY",attendeeEdit->text());
    attendeeListBox->insertItem(tmpStr.data());
  }
  attendeeEdit->setText("");
}

void EventWinDetails::removeAttendee()
{
  if (attendeeListBox->currentItem() >= 0)
    attendeeListBox->removeItem(attendeeListBox->currentItem());
}

void EventWinDetails::attendeeListHilite(int row, int /*col*/)
{
  attendeeEdit->setText(attendeeListBox->text(row, 0));
}

void EventWinDetails::attendeeListAction(int row, int col)
{
  switch (col) {
  case 0:
    // do something with the attendee here.
    break;
  case 3:
    if (strcmp(attendeeListBox->text(row, col), "Y") == 0)
      attendeeListBox->changeItemPart("N", row, col);
    else
      attendeeListBox->changeItemPart("Y", row, col);
    break;
  }
}

void EventWinDetails::openAddressBook()
{
//  addressBook = new AddressWidget;
//  addressBook->show();
}

