// 	$Id: eventwingeneral.cpp,v 1.17 1998/08/20 20:03:28 pbrown Exp $	

#include <kiconloader.h>

#include "eventwingeneral.h"
#include "eventwingeneral.moc"

EventWinGeneral::EventWinGeneral(QWidget* parent, const char* name, bool todo)
  : QFrame( parent, name, 0 )
{
  isTodo = todo;
  resize( 600,400 );
  if(isTodo) {
      initTodoSpecific();
  } else {
      initTimeBox();
      initAlarmBox();
  }
  initMisc();

  setMinimumSize( 600, 400 );
  setMaximumSize( 32767, 32767 );

  if (!isTodo) {
      QWidget::setTabOrder(summaryEdit, startDateEdit);
      QWidget::setTabOrder(startDateEdit, startTimeEdit);
      QWidget::setTabOrder(startTimeEdit, endDateEdit);
      QWidget::setTabOrder(endDateEdit, endTimeEdit);
      QWidget::setTabOrder(endTimeEdit, noTimeButton);
      QWidget::setTabOrder(noTimeButton, recursButton);
      QWidget::setTabOrder(recursButton, alarmButton);
      QWidget::setTabOrder(alarmButton, freeTimeCombo);
      QWidget::setTabOrder(freeTimeCombo, descriptionEdit);
      QWidget::setTabOrder(descriptionEdit, categoriesButton);
      QWidget::setTabOrder(categoriesButton, privateButton);
  } else {
      QWidget::setTabOrder(summaryEdit, completedButton);
      QWidget::setTabOrder(completedButton, completedCombo);
      QWidget::setTabOrder(completedCombo, priorityCombo);
      QWidget::setTabOrder(priorityCombo, descriptionEdit);
      QWidget::setTabOrder(descriptionEdit, categoriesButton);
      QWidget::setTabOrder(categoriesButton, privateButton);
  }
  summaryEdit->setFocus();
}

void EventWinGeneral::initTodoSpecific() {
    int ypos = 70, ystep = 30;

    completedButton = new QCheckBox(this, "CheckBox_10" );
    completedButton->setGeometry( 10, ypos, 140, 20 );
    completedButton->setText( i18n("Completed") );
        
    completedLabel = new QLabel( this, "Label_3" );
    completedLabel->setGeometry( 130, ypos, 70, 20 );
    completedLabel->setText( i18n("% Completed") );
    completedLabel->setAlignment( 289 );
    completedLabel->setMargin( -1 );

    completedCombo = new QComboBox( FALSE, this, "ComboBox_10" );
    completedCombo->setGeometry( 220, ypos, 100, 20 );
    completedCombo->setSizeLimit( 10 );
    completedCombo->insertItem( i18n("0 %") );
    completedCombo->insertItem( i18n("25 %") );
    completedCombo->insertItem( i18n("50 %") );
    completedCombo->insertItem( i18n("75 %") );
    completedCombo->insertItem( i18n("Completed") );

    //    ypos += ystep;

    priorityLabel = new QLabel( this, "Label_3" );
    priorityLabel->setGeometry( 360, ypos, 70, 20 );
    priorityLabel->setText( i18n("Priority") );
    priorityLabel->setAlignment( 289 );
    priorityLabel->setMargin( -1 );

    priorityCombo = new QComboBox( FALSE, this, "ComboBox_10" );
    priorityCombo->setGeometry( 430, ypos, 100, 20 );
    priorityCombo->setSizeLimit( 10 );
    priorityCombo->insertItem( i18n("1 (Highest)") );
    priorityCombo->insertItem( i18n("2") );
    priorityCombo->insertItem( i18n("3") );
    priorityCombo->insertItem( i18n("4") );
    priorityCombo->insertItem( i18n("5 (lowest)") );

}

void EventWinGeneral::initTimeBox()
{
  timeGroupBox = new QGroupBox( this, "User_2" );
  timeGroupBox->setTitle(i18n("Appointment Time"));
  timeGroupBox->setGeometry( 10, 70, 580, 80 );

  startLabel = new QLabel( this, "Label_2" );
  startLabel->setGeometry( 70, 90, 70, 20 );
  startLabel->setText( i18n("Start Time:") );
  startLabel->setAlignment( 289 );
  startLabel->setMargin( -1 );

  startDateEdit = new KDateEdit(this);
  startDateEdit->setGeometry( 140, 90, 130, 20 );

  endLabel = new QLabel( this, "Label_3" );
  endLabel->setGeometry( 70, 120, 70, 20 );
  endLabel->setText( i18n("End Time:") );
  endLabel->setAlignment( 289 );
  endLabel->setMargin( -1 );

  
  endDateEdit = new KDateEdit(this);
  endDateEdit->setGeometry( 140, 120, 130, 20 );

  startTimeEdit = new KTimeEdit(this);
  startTimeEdit->setGeometry( 280, 90, 105, 25 );
      
  endTimeEdit = new KTimeEdit(this);
  endTimeEdit->setGeometry( 280, 120, 105, 25 );

  noTimeButton = new QCheckBox(this, "CheckBox_1" );
  noTimeButton->setGeometry( 400, 90, 140, 20 );
  noTimeButton->setText( i18n("No time associated") );

  connect(noTimeButton, SIGNAL(toggled(bool)), 
	  this, SLOT(timeStuffDisable(bool)));
  connect(noTimeButton, SIGNAL(toggled(bool)),
	  this, SLOT(alarmStuffDisable(bool)));

  recursButton = new QCheckBox(this);
  recursButton->setGeometry( 400, 120, 140, 20);
  recursButton->setText(i18n("Recurring event"));
}

void EventWinGeneral::initMisc()
{

  summaryLabel = new QLabel( this, "Label_1" );
  summaryLabel->setGeometry( 10, 40, 70, 20 );
  summaryLabel->setText( i18n("Summary:") );
  summaryLabel->setAlignment( 289 );
  summaryLabel->setMargin( -1 );

  summaryEdit = new QLineEdit( this, "LineEdit_1" );
  summaryEdit->setGeometry( 80, 40, 510, 20 );

  if (!isTodo) {
  freeTimeLabel = new QLabel( this, "Label_6" );
  freeTimeLabel->setGeometry( 380, 160, 100, 20 );
  freeTimeLabel->setText( i18n("Show Time As:") );
  freeTimeLabel->setAlignment( 289 );
  freeTimeLabel->setMargin( -1 );

  freeTimeCombo = new QComboBox( FALSE, this, "ComboBox_1" );
  freeTimeCombo->setGeometry( 480, 160, 100, 20 );
  freeTimeCombo->setSizeLimit( 10 );
  freeTimeCombo->insertItem( i18n("Busy") );
  freeTimeCombo->insertItem( i18n("Free") );
  }

  descriptionEdit = new QMultiLineEdit( this, "MultiLineEdit_1" );
  if (!isTodo)
      descriptionEdit->setGeometry( 10, 200, 580, 150 );
  else
      descriptionEdit->setGeometry( 10, 100, 580, 250 );
  descriptionEdit->insertLine( "" );
  descriptionEdit->setReadOnly( FALSE );
  descriptionEdit->setOverwriteMode( FALSE );


  ownerLabel = new QLabel( this, "Label_7" );
  ownerLabel->setGeometry( 10, 10, 200, 20 );
  ownerLabel->setText( i18n("Owner:") );
  ownerLabel->setAlignment( 289 );
  ownerLabel->setMargin( -1 );

  privateButton = new QCheckBox( this, "CheckBox_3" );
  privateButton->setGeometry( 520, 360, 70, 20 );
  privateButton->setText( i18n("Private") );

  categoriesButton = new QPushButton( this, "PushButton_6" );
  categoriesButton->setGeometry( 10, 360, 100, 20 );
  categoriesButton->setText( i18n("Categories...") );

  categoriesEdit = new QLineEdit( this, "LineEdit_7" );
  categoriesEdit->setGeometry( 120, 360, 390, 20 );

}

void EventWinGeneral::initAlarmBox()
{
  if (isTodo) return;

  QLabel *alarmBell = new QLabel(this);
  alarmBell->setPixmap(QPixmap(Icon("bell.xpm")));
  alarmBell->adjustSize();
  alarmBell->move(10, 165);

  alarmButton = new QCheckBox( this, "CheckBox_2" );
  alarmButton->setGeometry( 40, 160, 80, 20 );
  alarmButton->setText( i18n("Reminder:") );

  alarmTimeEdit = new KRestrictedLine(this, "alarmTimeEdit",
				      "1234567890");
  alarmTimeEdit->setGeometry( 120, 160, 50, 20 );

  QLabel *alarmMinLabel = new QLabel(this);
  alarmMinLabel->setText("minute(s)");
  alarmMinLabel->setMinimumHeight(20);
  alarmMinLabel->adjustSize();
  alarmMinLabel->move(180, 160);

  alarmSoundButton = new QPushButton( this, "PushButton_4" );
  alarmSoundButton->setGeometry( 250, 160, 40, 20 );
  alarmSoundButton->setText( i18n("WAV") );

  alarmProgramButton = new QPushButton( this, "PushButton_5" );
  alarmProgramButton->setGeometry( 300, 160, 40, 20 );
  alarmProgramButton->setText( i18n("PROG") );

  connect(alarmButton, SIGNAL(toggled(bool)),
	  this, SLOT(alarmStuffEnable(bool)));


}

EventWinGeneral::~EventWinGeneral()
{
}

void EventWinGeneral::setEnable(bool)
{
}

void EventWinGeneral::timeStuffDisable(bool disable)
{
  if (isTodo) return;

  if (disable) {
    startTimeEdit->hide();
    endTimeEdit->hide();
  } else {
    startTimeEdit->show();
    endTimeEdit->show();
  }
  
}

void EventWinGeneral::alarmStuffEnable(bool enable)
{
  if (isTodo) return;

  alarmTimeEdit->setEnabled(enable);
  alarmSoundButton->setEnabled(enable);
  alarmProgramButton->setEnabled(enable);
}

void EventWinGeneral::alarmStuffDisable(bool disable)
{
  if (isTodo) return;

  alarmTimeEdit->setEnabled(!disable);
  alarmSoundButton->setEnabled(!disable);
  alarmProgramButton->setEnabled(!disable);
}


