/* 	$Id: kdpdatebutton.h,v 1.8 1998/03/26 03:24:03 pbrown Exp $	 */

#ifndef _KDPDATEBUTTON_H
#define _KDPDATEBUTTON_H

#include <qdatetm.h>
#include <qlabel.h>
#include <drag.h>

class KDateButton: public QLabel {
   Q_OBJECT
 public:
   
   enum { NoHilite,
	  SelectHilite,
	  EventHilite, TodayHilite };
   
   KDateButton(QDate date, int index, 
	       QWidget *parent=0, const char *name=0);
   ~KDateButton();
   QDate date();
   void setHiliteStyle(int HiliteStyle);
   int  hiliteStyle();
   
 public slots:
   void setDate(QDate newdate);

 signals:
   void selected(QDate, int, bool);

 protected slots:
   void doDrop(KDNDDropZone *);
   void doDropEnter(KDNDDropZone *);

 protected:
   void mousePressEvent(QMouseEvent *);

 private:
   int my_index;
   QDate bt_Date;
   int currHiliteStyle;
   QFont myFont;
   QPalette my_NormalPalette;
   QPalette my_HilitePalette;
   QPalette my_TodayPalette;
   QPalette my_EventPalette;
   QColorGroup my_NormalGroup;
   QColorGroup my_DisabledGroup;
   QColorGroup my_HiliteGroup;
   QColorGroup my_HiDisabledGroup;
   QColorGroup my_TodayGroup;
   QColorGroup my_EventGroup;
};

#endif // _KDPDATEBUTTON_H



