// mainview.cpp
// (c) 1998 by F.Zigterman and Preston Brown under GPL

// 	$Id: mainview.cpp,v 1.2 1998/01/17 05:48:45 pbrown Exp $	

#include "mainview.h"
#include "mainview.moc"

MainView::MainView( CalObject *calobject, QWidget *parent, char *name )
	: KNewPanner( parent, name, Vertical, Percent, 70 )
{
	QDate startDate;

	eventDB = calobject;
	viewType = AGENDAVIEW;
	startDate = QDate::currentDate();

	subPanner = new KNewPanner( this, "sub", Horizontal, Percent, 30 );
	dateSelector = new KDPDateTable( subPanner, eventDB, TRUE );
	agendaView = new KAgenda( startDate, eventDB, this );
	listView = new KTabListBox( this, "dayView", 3 );
	tabDlg = new QTabDialog( subPanner );
	eventDlg = new TextBox( tabDlg );
	todoList = new QListBox( tabDlg );
	listView->hide();
	activate( agendaView, subPanner );
	subPanner->activate( dateSelector, tabDlg );
	tabDlg->addTab( eventDlg, "Event" );
	tabDlg->addTab( todoList, "Todo" );
	tabDlg->setOKButton( "Confirm Changes" );
}

MainView::~MainView()
{
	deactivate();
	subPanner->deactivate();
	
	delete tabDlg;
	delete dateSelector;
	delete subPanner;
	delete listView;
	delete agendaView;
}
