
// $Id: optionsdlg.h,v 1.15 1998/08/20 04:21:35 pbrown Exp $
// (C) 1998 by Preston Brown, Fester Zigterman, and Christopher Beard

#ifndef __OPTION_H__
#define __OPTION_H__

#include <qtabdlg.h>
#include <qframe.h>
#include <qlined.h>
#include <qcombo.h>
#include <qchkbox.h>
#include <kconfig.h>
#include <qradiobt.h>
#include <qpushbt.h>

#include "kpropdlg.h"
#include "calobject.h"

/** Dialog to change the korganizer configuration.
  * @inherits KPropDlg
  */
class OptionsDialog : public KPropDlg
{
  Q_OBJECT
public:
  /** Initialize dialog and pages */
  OptionsDialog(CalObject *calPtr, const char *title, 
		QWidget *parent = 0, char *name = 0 );
  ~OptionsDialog();
  
signals:
  void closed(QWidget *);

protected slots:
  /** read the config from the KConfig object */
  void getConfig();
  /** Write the config to the KConfig object */
  void setConfig();

protected:
  /** These methods create the page contents */
  void setupMainTab();
  void setupTimeTab();
  void setupFontsTab();
  void setupColorsTab();
  void setupViewsTab();
  void setupDisplayTab();
  void setupPrinterTab();
  void closeEvent(QCloseEvent *);
  
  enum {Main, Time, View, Printer};
  QLabel *labelList[4][10];
  QLineEdit *lineEditList[4][10];
  static char *labeltext[4][5];
  static char *confignames[4][5];
	
private:
  
  QFrame *personalFrame;
  QLineEdit *nameEdit;
  QLineEdit *emailEdit;
  
  QFrame *timeFrame;
  QComboBox *timeCombo;
  QComboBox *tzCombo;
  
  QFrame *fontsFrame;
  QFrame *colorsFrame;
  QFrame *viewsFrame;
  QFrame *displayFrame;
  QFrame *printerFrame;
  
  /** pointer to kapp->getConfig(); */
  KConfig *config; 

  CalObject *calendar;
};

#endif
