/*

   	 $Id: printcontrol.h,v 1.1 1998/07/05 22:41:48 boloni Exp $	

	 Requires the Qt and KDE widget libraries, available at no cost at
	 http://www.troll.no and http://www.kde.org respectively
	 
	 Copyright (C) 1997, 1998 
	 Preston Brown (preston.brown@yale.edu)
	 Fester Zigterman (F.J.F.ZigtermanRustenburg@student.utwente.nl)
	 Ian Dawes (iadawes@globalserve.net)
	 Neil Hart (nhart@magma.ca)
	 
	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.
	 
	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
	 GNU General Public License for more details.
	 
	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _PRINTCONTROL_H
#define _PRINTCONTROL_H

#include <qobject.h>
#include <qprinter.h>
#include <qdatetm.h>

#include "printdialog.h"
#include "calobject.h"
#include "printjob.h"

/**
 *
 * This is the main class of the printing support for korganizer. It creates
 *  a QPrinter object on which to print, and handles requests from the user
 *  to print parts of the diary.
 *
 * @short controls printing of korganizer entries
 * @author Neil Hart
 * @version $Revision: 1.1 $
 */
class KDPPrintController : public QObject
{
	Q_OBJECT
public:
	/**
	 *
	 * Constructs a new printer controller
	 *
	 */
	KDPPrintController( );
	~KDPPrintController( );

  /**
   *
   * Responds to user selecting 'Print Setup' from menu
   */
	void Print_Setup( QWidget* parent );

  /**
   *
   * Responds to user selecting 'Print' from menu
   *
   */
	void Print( QWidget* parent, CalObject* cal );

public slots:
	void dialogClosed(bool);

protected:

	QPrinter prt;
	CalObject* calendar;
	QWidget* parentWidget;
	// we only allow one dialog to be active at any time
	KDPPrintDialog* printDialog;

};

#endif // _PRINTCONTROL_H

