/*

   	 $Id: printdialog.cpp,v 1.1 1998/07/05 22:41:48 boloni Exp $	

	 Requires the Qt and KDE widget libraries, available at no cost at
	 http://www.troll.no and http://www.kde.org respectively
	 
	 Copyright (C) 1997, 1998 
	 Preston Brown (preston.brown@yale.edu)
	 Fester Zigterman (F.J.F.ZigtermanRustenburg@student.utwente.nl)
	 Ian Dawes (iadawes@globalserve.net)
	 Neil Hart (nhart@magma.ca)
	 
	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.
	 
	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
	 GNU General Public License for more details.
	 
	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <kapp.h>

#include "printdialog.h"
#include "printdialog.moc"

KDPPrintDialog::KDPPrintDialog( const char* name )
	// note that this has to be a modeless dialog, otherwise the
	// KDatePicker will never get keyboard focus
	: QDialog( 0, name, FALSE )
{
	startDateEditLabel = new QLabel( this, "Label_1" );
	startDateEditLabel->setGeometry( 10, 30, 140, 20 );
	startDateEditLabel->setMinimumSize( 10, 10 );
	startDateEditLabel->setMaximumSize( 32767, 32767 );
	startDateEditLabel->setText( "Start Date:" );
	// startDateEditLabel->setAlignment( );
	// startDateEditLabel->setMargin( -1 );

	startDateEdit = new KDateEdit( this );
	startDateEdit->setGeometry( 160, 30, 140, 20 );
	startDateEdit->setEnabled( TRUE );

	endDateEditLabel = new QLabel( this, "Label_2" );
	endDateEditLabel->setGeometry( 10, 60, 140, 20 );
	endDateEditLabel->setMinimumSize( 10, 10 );
	endDateEditLabel->setMaximumSize( 32767, 32767 );
	endDateEditLabel->setText( "End Date:" );
	// endDateEditLabel->setAlignment( );
	// endDateEditLabel->setMargin( -1 );

	endDateEdit = new KDateEdit( this );
	endDateEdit->setGeometry( 160, 60, 140, 20 );
	endDateEdit->setEnabled( TRUE );

	formatComboLabel = new QLabel( this, "Label_3" );
	formatComboLabel->setGeometry( 10, 90, 140, 20 );
	formatComboLabel->setMinimumSize( 10, 10 );
	formatComboLabel->setMaximumSize( 32767, 32767 );
	formatComboLabel->setText( "Format:" );
	// formatComboLabel->setAlignment( );
	// formatComboLabel->setMargin( -1 );

	formatCombo = new QComboBox( FALSE, this, "Combo_1" );
	formatCombo->setGeometry( 150, 90, 140, 20 );
	formatCombo->setMinimumSize( 10, 10 );
	formatCombo->setMaximumSize( 32767, 32767 );
	formatCombo->insertItem( "List View", 0 );

	layoutComboLabel = new QLabel( this, "Label_4" );
	layoutComboLabel->setGeometry( 10, 120, 140, 20 );
	layoutComboLabel->setMinimumSize( 10, 10 );
	layoutComboLabel->setMaximumSize( 32767, 32767 );
	layoutComboLabel->setText( "Layout:" );
	// layoutComboLabel->setAlignment( );
	// layoutComboLabel->setMargin( -1 );

	layoutCombo = new QComboBox( FALSE, this, "Combo_2" );
	layoutCombo->setGeometry( 150, 120, 140, 20 );
	layoutCombo->setMinimumSize( 10, 10 );
	layoutCombo->setMaximumSize( 32767, 32767 );
	layoutCombo->insertItem( "Full Page", 0 );
	layoutCombo->insertItem( "Half Page", 1 );

	okButton = new QPushButton( klocale->translate("Ok"), this );
	okButton->setGeometry( 10, 150, 100, 20 );
	connect( okButton, SIGNAL(clicked()), SLOT( okButtonPressed()) );

	cancelButton = new QPushButton( klocale->translate("Cancel"), this );
	cancelButton->setGeometry( 120, 150, 100, 20 );
	connect( cancelButton, SIGNAL(clicked()), SLOT( cancelButtonPressed()) );

}

KDPPrintDialog::~KDPPrintDialog( )
{
	delete startDateEditLabel;
	delete startDateEdit;
	delete endDateEditLabel;
	delete endDateEdit;
	delete formatComboLabel;
	delete formatCombo;
	delete layoutComboLabel;
	delete layoutCombo;
}

void KDPPrintDialog::okButtonPressed( )
{
	emit buttonPressed( true );
}

void KDPPrintDialog::cancelButtonPressed( )
{
	emit buttonPressed( false );
}

QDate KDPPrintDialog::getStartDate()
{
	return startDateEdit->getDate();
}

QDate KDPPrintDialog::getEndDate()
{
	return endDateEdit->getDate();
}

int KDPPrintDialog::getFormat()
{
	return formatCombo->currentItem();
}

int KDPPrintDialog::getLayout()
{
	return layoutCombo->currentItem();
}

