/*

   	 $Id: printdialog.h,v 1.1 1998/07/05 21:36:43 boloni Exp $	

	 Requires the Qt and KDE widget libraries, available at no cost at
	 http://www.troll.no and http://www.kde.org respectively
	 
	 Copyright (C) 1997, 1998 
	 Preston Brown (preston.brown@yale.edu)
	 Fester Zigterman (F.J.F.ZigtermanRustenburg@student.utwente.nl)
	 Ian Dawes (iadawes@globalserve.net)
	 Neil Hart (nhart@magma.ca)
	 Laszlo Boloni (boloni@cs.purdue.edu)
	 
	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.
	 
	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
	 GNU General Public License for more details.
	 
	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _PRINTDIALOG_H
#define _PRINTDIALOG_H

#include <qdialog.h>
#include <qdatetm.h>
#include <qcombo.h>
#include <qlabel.h>
#include <qchkbox.h>

#include "kdated.h"
//#include "kprocess.h"
#include "calobject.h"

/**
 *
 * This dialog allows the user to determine which dates to print and
 *  in what format.
 *
 * @short dialog for printing
 * @author Neil Hart
 * @version $Revision: 1.1 $
 */

class KDPPrintDialog : public QDialog
{
	Q_OBJECT
public:
	/**
	 *
	 * Constructs a new print dialog
	 *
	 */
  KDPPrintDialog( const char* name, CalObject *cal);
  virtual ~KDPPrintDialog( );
  static KDPPrintDialog* getInstance(CalObject *cal);
  QDate getStartDate();
  QDate getEndDate();
  int getFormat();
  int getLayout();

signals:
  void buttonPressed( bool );
protected slots:
	void printButtonPressed( );
	void previewButtonPressed( );
	void cancelButtonPressed( );

protected:
  CalObject *calendar;

  QLabel*	startDateEditLabel;
  KDateEdit*	startDateEdit;
  QLabel*	endDateEditLabel;
  KDateEdit*	endDateEdit;
  QLabel*	formatComboLabel;
  QComboBox*	formatCombo;
  QLabel*	layoutComboLabel;
  QComboBox*	layoutCombo;
  QPushButton*	printButton;
  QPushButton*	previewButton;
  QPushButton*	cancelButton;
private:
  static KDPPrintDialog* _instance;
};



#endif // _PRINTDIALOG_H

