// SearchDialog for KOrganizer
// (c) 1998 by Preston Brown
//

#include "searchdialog.h"
#include "searchdialog.moc"

SearchDialog::SearchDialog(CalObject *_cal) :
  QDialog(0, "Search - KOrganizer")
{
  cal = _cal;
  setFixedSize(500, 300);
  searchLabel = new QLabel(this, "searchLabel");
  searchLabel->setText("Search For:");
  searchLabel->move(10,10);
  searchLabel->adjustSize();

  searchEdit = new QLineEdit(this);
  searchEdit->setFixedWidth(300);
  searchEdit->move(searchLabel->geometry().topRight().x()+10,
		   searchLabel->geometry().topRight().y());
  searchEdit->adjustSize();
  
  searchButton = new QPushButton(this, "searchButton");
  searchButton->setText("Search");
  searchButton->move(searchEdit->geometry().topRight().x()+10,
		     searchLabel->geometry().topRight().y());
  searchButton->setDefault(TRUE);
  searchButton->adjustSize();

  connect(searchButton, SIGNAL(clicked()),
	  this, SLOT(doSearch()));
  
  listView = new BaseListView(cal, this);
  listView->move(10, searchEdit->geometry().bottomLeft().y()+10);
  listView->resize(this->width()-20, (this->height() - listView->geometry().topLeft().y())-40);
  
  QPushButton *ok;
  ok = new QPushButton( "Close", this );
  ok->move(this->width()-100, (this->height()-30));
  ok->adjustSize();
  connect( ok, SIGNAL(clicked()), SLOT(accept()) );

  this->adjustSize();

  listView->showDates();
  searchEdit->setFocus();

  connect(listView, SIGNAL(editEventSignal(KDPEvent *)),
	  this, SIGNAL(editEventSignal(KDPEvent *)));
  connect(listView, SIGNAL(deleteEventSignal(KDPEvent *)),
	  this, SIGNAL(deleteEventSignal(KDPEvent *)));
}

void SearchDialog::doSearch()
{
  QRegExp re;
  QList<KDPEvent> matchedEvents;

  re.setCaseSensitive(FALSE);
  re = searchEdit->text();
  if (!re.isValid()) {
    printf("invalid search regexp\n");
    return;
  }
  matchedEvents = cal->search(re);

  listView->setEventList(matchedEvents);
}

SearchDialog::~SearchDialog()
{
  delete searchLabel;
  delete searchEdit;
  delete listView;
}

/***************************************************************************************************/
void SearchDialog::closeEvent(QCloseEvent *)
{
  // we clean up after ourselves...
  emit closed(this);
}
